{"openapi":"3.0.1","info":{"title":"Funding Rejects","description":"This API enables institutions to view and modify funding information as per configuration. Version 1.0.0.","version":"1.0.0","contact":{"name":"Fiserv EMEA Developer Portal","url":"https://support.fiserv.com/en/knowledge","email":"support@20080132.hubspot-inbox.com"},"termsOfService":"https://fiserv.dev/legal"},"servers":[{"url":"https://prod.emea.api.fiservapps.com/exp/v1","description":"Production"}],"tags":[{"name":"Funding Rejects","description":"This API enables institutions to view and modify funding information as per configuration."}],"paths":{"/funding-rejects":{"get":{"summary":"Retrieve Funding Rejects","description":"Retrieves a paginated list of funding rejects. The results can be fitered by any one or more query parameters passed as input in the API Request.","operationId":"getFundingRejects","tags":["Funding Rejects"],"parameters":[{"$ref":"#/components/parameters/Institution-Number"},{"schema":{"type":"string","example":"1234567890","pattern":"^[a-zA-Z0-9]{1,20}$","minLength":1,"maxLength":20},"name":"merchantId","in":"query","required":false,"description":"For use by an alliance or partner when there is a need to filter on a specific merchant within their scope. May be restricted based on the API key."},{"schema":{"type":"string","items":{"type":"string","example":"003,005","minLength":3}},"name":"status","in":"query","required":false,"description":"Current status of the funding reject whether it has been funded to the merchant account or still rejected. This field should contain the 3 digit status index.\n\n| Code | Status |\n|---|---|\n| 003 | Error |\n| 005 | Loaded |\n| 008 | Approved |\n| 032 | Matched |\n| 104 | Cheque issued |\n| 105 | Returned |\n| 106 | Centralise |\n| 107 | Penalise |\n| 109 | Decentralise |\n| 110 | Applied PyG |"},{"schema":{"type":"string","pattern":"^([0-9]{4})(-?)(1[0-2]|0[1-9])\\2(3[01]|0[1-9]|[12][0-9])$","minLength":8,"maxLength":8},"name":"rejectedAfter","in":"query","required":false,"description":"Extract funding rejects that were `posted` to merchant account after this date. The date format is `YYYY-MM-DD`. **Default**: Date will be 'current institution posting date - 1' if this query parameter not provided."},{"schema":{"type":"string","pattern":"^([0-9]{4})(-?)(1[0-2]|0[1-9])\\2(3[01]|0[1-9]|[12][0-9])$","minLength":8,"maxLength":8},"name":"rejectedBefore","in":"query","required":false,"description":"Extract funding rejects that were `posted` to merchant account before this date. The date format is `YYYY-MM-DD`. **Default**: Date will be current institution posting date if this query parameter not provided."},{"schema":{"type":"integer","format":"int32","minimum":0,"default":0},"name":"offset","in":"query","required":false,"description":"Starting point to start retrieving the elements from. This can be used with \"limit\". Can be used for page/offset based pagination."},{"schema":{"type":"integer","format":"int32","minimum":1,"maximum":100,"default":20},"name":"limit","in":"query","required":false,"description":"Number of elements to be returned in a single query. Can be used for page/offset or cursor based pagination."},{"schema":{"type":"string"},"name":"sort","in":"query","required":false,"description":"Defines how to sort the records that are returned. Must be specified in the syntax '+' (ascending) or '-' (descending) followed by the field name. **Valid values**: `+posted` for ascending and `-posted` for descending. **Default**: `+posted`"},{"schema":{"type":"string","items":{"type":"string","example":"12345678901","pattern":"^[0-9]{1,11}$","minLength":1,"maxLength":11}},"name":"fundingId","in":"query","required":false,"description":"Unique system identifier of the record in OmniPay system."}],"responses":{"200":{"description":"OK","headers":{"Has-More-Records":{"schema":{"type":"boolean","description":"Used for pagination based on the given limit and offset.  Contains `true` if there are more results beyond the current `page`,  otherwise `false`."},"required":true},"Trace-Id":{"schema":{"minLength":36,"maxLength":36,"type":"string","format":"UUID","example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An internal unique ID for this request which can be used for diagnosing issues and corresponding with support.","required":true}},"content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/FundingRejectResponse"}},"examples":{"Retrieve funding rejects":{"value":[{"id":"12345678901","reason":"01UAR0000No Sending Bank Info for pymt fmt (000) tran type (02) curr (CAD)","reprocessedDate":"20200615","posted":"20200615","lastUpdatedBy":"John Smith","status":{"code":"005","description":"LOADED"},"merchant":{"id":"0000075999959","tradeName":"Insomnia"},"originalPayment":{"fundingId":"12345678901","funded":"20200615","amount":"10.00"},"account":{"sortCode":"13165987","accountNumber":"ZZ999999999999999","iban":"ZZ99999999999999999999","currencyCode":"EUR"}}]}}}}},"400":{"$ref":"#/components/responses/InvalidRequest-400"},"401":{"$ref":"#/components/responses/AuthorizationError-401"},"403":{"$ref":"#/components/responses/ForbiddenError-403"},"404":{"$ref":"#/components/responses/Invalidrecord-404"},"429":{"$ref":"#/components/responses/TooManyRequests-429"},"500":{"$ref":"#/components/responses/InternalServerError-500"}},"security":[{"AppKey":[]}]},"patch":{"summary":"Update Funding Reject Status","description":"This operation allows to modify Funding Reject statuses for a list of funding ids.","operationId":"updateFundingReject","tags":["Funding Rejects"],"parameters":[{"$ref":"#/components/parameters/Institution-Number"},{"$ref":"#/components/parameters/Message-Signature"}],"requestBody":{"description":"Status being modified per Funding ID.","content":{"application/json":{"schema":{"type":"array","items":{"$ref":"#/components/schemas/UpdateFundingReject","minItems":1}},"example":{"value":[{"fundingId":"12345678901","status":"005"},{"fundingId":"12345678902","status":"003"}]}}}},"responses":{"204":{"description":"No content","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}}},"400":{"$ref":"#/components/responses/InvalidRequest-400"},"401":{"$ref":"#/components/responses/AuthorizationError-401"},"403":{"$ref":"#/components/responses/ForbiddenError-403"},"404":{"$ref":"#/components/responses/Invalidrecord-404"},"422":{"$ref":"#/components/responses/Unprocessable-422"},"429":{"$ref":"#/components/responses/TooManyRequests-429"},"500":{"$ref":"#/components/responses/InternalServerError-500"}},"security":[{"AppKey":[]}]}}},"components":{"parameters":{"Institution-Number":{"name":"Institution-Number","in":"header","description":"Institution number (8-digit number) associated with the merchant. This information defines the acquirer for the merchant. If a consumer is granted access to this API for multiple institutions, this field must be populated. If access is for only one institution, the API will automatically determine this value, making it optional for the client.","required":false,"schema":{"type":"string"}},"Message-Signature":{"name":"Message-Signature","in":"header","description":"Used to ensure the request has not been tampered with during transmission. The Message-Signature is the Base64 encoded HMAC hash (SHA256 algorithm with the API Secret as the key.) For more information, refer to the supporting documentation on the Developer Portal.","required":true,"schema":{"type":"string"}}},"schemas":{"FundingRejectResponse":{"type":"object","x-examples":{},"properties":{"id":{"description":"Slip number of Funding Reject","example":"12345678901","maxLength":11,"minLength":1,"pattern":"^[0-9]{1,11}$","type":"string"},"reason":{"description":"The reason for rejected funding. Appears as populated by institution on funding reject file submission to the OmniPay platform.","example":"01UAR0000No Sending Bank Info for pymt fmt (000) tran type (02) curr (CAD)","type":"string"},"reprocessedDate":{"description":"Date when the rejected funding amount is resubmitted on funding file. Format YYYYMMDD.","example":"20200615","maxLength":8,"minLength":8,"pattern":"^([0-9]{4})(-?)(1[0-2]|0[1-9])\\2(3[01]|0[1-9]|[12][0-9])$","type":"string"},"posted":{"description":"The date the rejected funding amount is posted on the system. Format YYYYMMDD.","example":"20200615","maxLength":8,"minLength":8,"pattern":"^([0-9]{4})(-?)(1[0-2]|0[1-9])\\2(3[01]|0[1-9]|[12][0-9])$","type":"string"},"lastUpdatedBy":{"description":"Contact name of the person or system description that last updated the record.","example":"John Smith","maxLength":60,"minLength":0,"pattern":"^[a-zA-Z0-9À-ý_ \\.\\&\\,]{0,60}$","type":"string"},"status":{"description":"The status of the funding reject. For a list of valid funding statuses, use use Acquirer Profile API get reference-data endpoint with query parameter classification equal 'fundingRejectStatus'.\r\n\r\n\r\nColumn A | Column C\r\n---------|---------\r\n| 003 | Error \r\n| 005 | Loaded \r\n| 008 | Approved \r\n| 032 | Matched \r\n| 104 | Cheque issued \r\n| 105 | Returned \r\n| 106 | Centralise \r\n| 107 | Penalise \r\n| 109 | Decentralise \r\n| 110 | Applied PyG","type":"object","properties":{"code":{"type":"string","x-stoplight":{"id":"wagshegt91k8x"},"description":"The status of the funding reject. For a list of valid funding statuses, use use Acquirer Profile API get reference-data endpoint with query parameter classification equal 'fundingRejectStatus'.","pattern":"^[0-9]{3,3}$","example":"005","minLength":3,"maxLength":3},"description":{"type":"string","x-stoplight":{"id":"7pnoz519d52qn"},"description":"Description of the funding reject code.","example":"LOADED","minLength":0,"maxLength":20}}},"merchant":{"title":"Merchant","type":"object","x-examples":{"batchExample":{"id":"0000075999959","tradeName":"Insomnia"}},"x-tags":["Models"],"properties":{"id":{"description":"Merchant number to be used throughout the authorization and clearing cycle.","example":"0000075999959","maxLength":20,"minLength":1,"pattern":"^[a-zA-Z0-9]{1,20}$","type":"string"},"tradeName":{"description":"Merchant Trade Name. There is no pattern defined for this field. UTF8 characters (extended ASCII characters) are supported for this field. Maximum length of this field is defined in bytes and special character of any extended ASCII character can be more than 1 byte for each character. Consumer should consider number of bytes for maximum length determination. For example, if consume wants to provide three 2-bytes ASCII character, then actual length of the provided data is 6, not 3.","example":"Insomnia","maxLength":22,"minLength":1,"type":"string"}}},"originalPayment":{"title":"Original Payment","type":"object","x-examples":{"batchExample":{"fundingId":"12345678901","funded":"20200615","amount":"250.00"}},"x-tags":["Models"],"properties":{"fundingId":{"description":"Slip number of the original funding amount.","example":"12345678901","maxLength":11,"minLength":1,"pattern":"^[0-9]{1,11}$","type":"string"},"funded":{"description":"The date of the original funding amount which became rejected was posted on the system. Format YYYYMMDD.","example":"20200615","maxLength":8,"minLength":8,"pattern":"^([0-9]{4})(-?)(1[0-2]|0[1-9])\\2(3[01]|0[1-9]|[12][0-9])$"},"amount":{"description":"Value of rejected funding.","example":"10.00","maxLength":18,"minLength":0,"pattern":"^[0-9_\\-\\.\\+]{0,18}$","type":"string"}}},"account":{"title":"Account","type":"object","x-examples":{"batchExample":{"sortCode":"13165987","accountNumber":"ZZ999999999999999","iban":"ZZ99999999999999999999","currencyCode":"EUR"}},"x-tags":["Models"],"properties":{"sortCode":{"description":"Clearing number of the merchant's bank i.e. the sort code or BSB number (Australia).","example":"13165987","maxLength":22,"minLength":0,"pattern":"^[A-Z0-9_ \\.\\&\\,\\-\\/]{0,22}$"},"accountNumber":{"description":"Merchant's bank account number. This is considered PII data; the value will be encrypted prior to storing.","type":"string","example":"ZZ999999999999999","maxLength":35,"minLength":0,"pattern":"^[A-Z0-9 \\-\\/\\.]{0,35}$"},"iban":{"description":"International Bank Account Number (IBAN) is a series of alphanumeric characters that uniquely identifies a customer's account held at a bank anywhere in the world. this is considered PII data; the value will be encrypted prior to storing.","type":"string","example":"ZZ99999999999999999999","maxLength":35,"minLength":0,"pattern":"^[A-Z0-9 \\-\\/\\.]{0,35}$"},"currencyCode":{"description":"ISO 4217 currency of the account selected, possible values are restricted based on the institution configuration. For a list of valid codes use Acquirer Profile API GET /service-contracts/serviceContractIndex/account-settlement.","example":"EUR","maxLength":3,"minLength":3,"pattern":"^[a-zA-Z]{3,3}$","type":"string"}}}}},"Error":{"description":"This is the generic Error Response to be used for all Errors sent back in responses.","type":"object","title":"Error Response","properties":{"errors":{"type":"array","uniqueItems":false,"items":{"type":"object","additionalProperties":false,"properties":{"title":{"type":"string","description":"Readable error message that could be displayed in a UI"},"detail":{"type":"string","description":"Further description provided to give wider context into the error"},"source":{"type":"string","description":"Optional: Known source of error such as missing or invalid field in a request"}},"required":["title","detail"]}}},"required":["errors"],"x-tags":["Meta"]},"UpdateFundingReject":{"title":"Update Funding Reject","type":"object","x-examples":{"batchExample":{"fundingId":"12345678901","status":"005"}},"x-tags":["Models"],"x-stoplight":{"id":"gya81kfol96ns"},"properties":{"fundingId":{"description":"Slip number of the original funding amount.","example":"12345678901","maxLength":11,"minLength":1,"pattern":"^[0-9]{1,11}$","type":"string"},"status":{"description":"The status of the funding reject. For a list of valid funding statuses, use Acquirer Profile API get reference-data endpoint with query parameter classification equal fundingRejectStatus.","example":"005","maxLength":3,"minLength":3,"type":"string"}},"required":["fundingId","status"]}},"securitySchemes":{"AppKey":{"type":"apiKey","description":"Unique App Key to use this API that you must have obtained at the time of app registration. Please check you developer account to find the App Key to be used.","in":"header","name":"Api-Key"}},"examples":{"example-400":{"summary":"Invalid request","value":{"errors":[{"title":"Bad Request - Incorrect or Missing Query Parameter/Header/Field","detail":"There is a validation error. Please fix and repeat your request."}]}},"example-401":{"summary":"Authentication error","value":{"errors":[{"title":"Authentication error","detail":"No valid API key or credential has been provided in the request."}]}},"example-403":{"summary":"Forbidden error","value":{"errors":[{"title":"Forbidden error","detail":"Access to the requested resource is forbidden."}]}},"example-404":{"summary":"Resource not found","value":{"errors":[{"title":"Resource not found","detail":"The requested resource cannot be found."}]}},"example-422":{"summary":"Payload validation error","value":{"errors":[{"title":"Invalid reject status","detail":"The status is unknown for funding id","source":"fundingId 00000000001, 00000000002"}]}},"example-429":{"value":{"errors":[{"title":"Too many requests","detail":"Too many requests have been received too quickly. Please back off your requests and try again."}]}},"example-500":{"value":{"errors":[{"title":"Internal server error","detail":"Sorry, something has gone wrong at our end. If this persists please contact support and provide the value of your Trace-Id header."}]}}},"responses":{"InvalidRequest-400":{"description":"Invalid request","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"InvalidParameter":{"$ref":"#/components/examples/example-400"}}}}},"AuthorizationError-401":{"description":"Authorization error","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"authenticationError":{"$ref":"#/components/examples/example-401"}}}}},"ForbiddenError-403":{"description":"Forbidden error","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"authenticationError":{"$ref":"#/components/examples/example-403"}}}}},"Invalidrecord-404":{"description":"Record does not exist","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"authenticationError":{"$ref":"#/components/examples/example-404"}}}}},"Unprocessable-422":{"description":"Unprocessable Entity","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"UnprocessableError":{"$ref":"#/components/examples/example-422"}}}}},"TooManyRequests-429":{"description":"Too many requests","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"authenticationError":{"$ref":"#/components/examples/example-429"}}}}},"InternalServerError-500":{"description":"Internal Server Error","headers":{"Trace-Id":{"schema":{"type":"string","format":"uuid","minLength":36,"maxLength":36,"example":"9591e6d8-0d70-11ea-8d71-362b9e155667"},"description":"An RFC4122 UUID used as to trace requests"}},"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"},"examples":{"InternalServerError":{"$ref":"#/components/examples/example-500"}}}}}}},"x-readme":{"explorer-enabled":true,"proxy-enabled":true}}